/* Last modified on August 22nd, 2002 */


/* This file contains wrapper functions that are callable directly
   from a FORTRAN program -- Mainly, it's a rewrite/translation of the
   data structures so that they comply with the FORTRAN argument
   passing conventions.

   The 'makefile' gives details regarding the compilation. Note that it
   may not work with combinations of compilers other than 'gcc' and
   'g77' due to non trivial differences in the binary layout of
   different compilers.

*/


#include <stdio.h>
#include <stdlib.h>
#include "libCk.h"


void f_init_workspace(int *N){
  init_workspace(*N);
}

void f_create_exponent_table(int *NF){
  create_exponent_table(*NF);
}

void f_create_ck_table(double *Qs, double *t_k, double *t_C, double *avgkt, double *sumrule, double *k_min, double *k_max, int *Nk){
  table_C *t;
  int i;
  t=create_Ck_table(*Qs,*Nk);
  *sumrule=t->sum_rule;
  *avgkt=t->avg_kt;
  *k_min=t->kmin;
  *k_max=t->kmax;
  for(i=0;i<(*Nk)+3000;i++){
    t_k[i]=(t->tbl_k)[i];
    t_C[i]=(t->tbl_C)[i];
  }
  free(t->tbl_k);
  free(t->tbl_C);
  free(t);
}

double f_c_itp(double *k, double *t_k, double *t_C, int *N){
  return interpolate_from_1(t_k,t_C,*k,*N);
}
